/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_PRICE_LOCK_PROGRAM_ADDRESS } from '../programs';
export type LockOrderInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountTaker extends string | IAccountMeta<string> = string, TAccountDeprecatedCosigner extends string | IAccountMeta<string> = string, TAccountOrderState extends string | IAccountMeta<string> = string, TAccountOrderVault extends string | IAccountMeta<string> = string, TAccountMaker extends string | IAccountMeta<string> = string, TAccountMarginAccount extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountTensorswapProgram extends string | IAccountMeta<string> = 'TSWAPaqyCSx2KABk68Shruf4rp7CxcNi8hAsbdwmHbN', TAccountTlockProgram extends string | IAccountMeta<string> = 'TLoCKic2wGJm7VhZKumih4Lc35fUhYqVMgA4j389Buk', TAccountOrderNftReceipt extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountTaker extends string ? WritableSignerAccount<TAccountTaker> & IAccountSignerMeta<TAccountTaker> : TAccountTaker,
    TAccountDeprecatedCosigner extends string ? ReadonlyAccount<TAccountDeprecatedCosigner> : TAccountDeprecatedCosigner,
    TAccountOrderState extends string ? WritableAccount<TAccountOrderState> : TAccountOrderState,
    TAccountOrderVault extends string ? WritableAccount<TAccountOrderVault> : TAccountOrderVault,
    TAccountMaker extends string ? WritableAccount<TAccountMaker> : TAccountMaker,
    TAccountMarginAccount extends string ? WritableAccount<TAccountMarginAccount> : TAccountMarginAccount,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountTensorswapProgram extends string ? ReadonlyAccount<TAccountTensorswapProgram> : TAccountTensorswapProgram,
    TAccountTlockProgram extends string ? ReadonlyAccount<TAccountTlockProgram> : TAccountTlockProgram,
    TAccountOrderNftReceipt extends string ? WritableAccount<TAccountOrderNftReceipt> : TAccountOrderNftReceipt,
    ...TRemainingAccounts
]>;
export type LockOrderInstructionData = {
    discriminator: ReadonlyUint8Array;
    price: bigint;
    nonce: number;
    aprBps: number;
    durationSec: number;
    earlyClose: boolean;
};
export type LockOrderInstructionDataArgs = {
    price: number | bigint;
    nonce: number;
    aprBps: number;
    durationSec?: number;
    earlyClose?: boolean;
};
export declare function getLockOrderInstructionDataEncoder(): Encoder<LockOrderInstructionDataArgs>;
export declare function getLockOrderInstructionDataDecoder(): Decoder<LockOrderInstructionData>;
export declare function getLockOrderInstructionDataCodec(): Codec<LockOrderInstructionDataArgs, LockOrderInstructionData>;
export type LockOrderAsyncInput<TAccountFeeVault extends string = string, TAccountTaker extends string = string, TAccountDeprecatedCosigner extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountMaker extends string = string, TAccountMarginAccount extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountTensorswapProgram extends string = string, TAccountTlockProgram extends string = string, TAccountOrderNftReceipt extends string = string> = {
    feeVault?: Address<TAccountFeeVault>;
    taker: TransactionSigner<TAccountTaker>;
    /** Deprecated: In place for backwards compatibility, but can be left to default to program_id. */
    deprecatedCosigner?: Address<TAccountDeprecatedCosigner>;
    orderState: Address<TAccountOrderState>;
    orderVault?: Address<TAccountOrderVault>;
    maker: Address<TAccountMaker>;
    marginAccount?: Address<TAccountMarginAccount>;
    makerBroker?: Address<TAccountMakerBroker>;
    takerBroker?: Address<TAccountTakerBroker>;
    tokenProgram?: Address<TAccountTokenProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    tensorswapProgram?: Address<TAccountTensorswapProgram>;
    tlockProgram?: Address<TAccountTlockProgram>;
    /** The NFT deposit receipt account, which tracks an NFT to the order state it was deposited to. */
    orderNftReceipt?: Address<TAccountOrderNftReceipt>;
    price: LockOrderInstructionDataArgs['price'];
    nonce: LockOrderInstructionDataArgs['nonce'];
    aprBps: LockOrderInstructionDataArgs['aprBps'];
    durationSec?: LockOrderInstructionDataArgs['durationSec'];
    earlyClose?: LockOrderInstructionDataArgs['earlyClose'];
};
export declare function getLockOrderInstructionAsync<TAccountFeeVault extends string, TAccountTaker extends string, TAccountDeprecatedCosigner extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountMaker extends string, TAccountMarginAccount extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountTensorswapProgram extends string, TAccountTlockProgram extends string, TAccountOrderNftReceipt extends string>(input: LockOrderAsyncInput<TAccountFeeVault, TAccountTaker, TAccountDeprecatedCosigner, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountMarginAccount, TAccountMakerBroker, TAccountTakerBroker, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTensorswapProgram, TAccountTlockProgram, TAccountOrderNftReceipt>): Promise<LockOrderInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTaker, TAccountDeprecatedCosigner, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountMarginAccount, TAccountMakerBroker, TAccountTakerBroker, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTensorswapProgram, TAccountTlockProgram, TAccountOrderNftReceipt>>;
export type LockOrderInput<TAccountFeeVault extends string = string, TAccountTaker extends string = string, TAccountDeprecatedCosigner extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountMaker extends string = string, TAccountMarginAccount extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountTensorswapProgram extends string = string, TAccountTlockProgram extends string = string, TAccountOrderNftReceipt extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    taker: TransactionSigner<TAccountTaker>;
    /** Deprecated: In place for backwards compatibility, but can be left to default to program_id. */
    deprecatedCosigner?: Address<TAccountDeprecatedCosigner>;
    orderState: Address<TAccountOrderState>;
    orderVault: Address<TAccountOrderVault>;
    maker: Address<TAccountMaker>;
    marginAccount?: Address<TAccountMarginAccount>;
    makerBroker?: Address<TAccountMakerBroker>;
    takerBroker?: Address<TAccountTakerBroker>;
    tokenProgram?: Address<TAccountTokenProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    tensorswapProgram?: Address<TAccountTensorswapProgram>;
    tlockProgram?: Address<TAccountTlockProgram>;
    /** The NFT deposit receipt account, which tracks an NFT to the order state it was deposited to. */
    orderNftReceipt?: Address<TAccountOrderNftReceipt>;
    price: LockOrderInstructionDataArgs['price'];
    nonce: LockOrderInstructionDataArgs['nonce'];
    aprBps: LockOrderInstructionDataArgs['aprBps'];
    durationSec?: LockOrderInstructionDataArgs['durationSec'];
    earlyClose?: LockOrderInstructionDataArgs['earlyClose'];
};
export declare function getLockOrderInstruction<TAccountFeeVault extends string, TAccountTaker extends string, TAccountDeprecatedCosigner extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountMaker extends string, TAccountMarginAccount extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountTensorswapProgram extends string, TAccountTlockProgram extends string, TAccountOrderNftReceipt extends string>(input: LockOrderInput<TAccountFeeVault, TAccountTaker, TAccountDeprecatedCosigner, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountMarginAccount, TAccountMakerBroker, TAccountTakerBroker, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTensorswapProgram, TAccountTlockProgram, TAccountOrderNftReceipt>): LockOrderInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTaker, TAccountDeprecatedCosigner, TAccountOrderState, TAccountOrderVault, TAccountMaker, TAccountMarginAccount, TAccountMakerBroker, TAccountTakerBroker, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTensorswapProgram, TAccountTlockProgram, TAccountOrderNftReceipt>;
export type ParsedLockOrderInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        feeVault: TAccountMetas[0];
        taker: TAccountMetas[1];
        /** Deprecated: In place for backwards compatibility, but can be left to default to program_id. */
        deprecatedCosigner?: TAccountMetas[2] | undefined;
        orderState: TAccountMetas[3];
        orderVault: TAccountMetas[4];
        maker: TAccountMetas[5];
        marginAccount?: TAccountMetas[6] | undefined;
        makerBroker?: TAccountMetas[7] | undefined;
        takerBroker?: TAccountMetas[8] | undefined;
        tokenProgram: TAccountMetas[9];
        systemProgram: TAccountMetas[10];
        associatedTokenProgram: TAccountMetas[11];
        tensorswapProgram: TAccountMetas[12];
        tlockProgram: TAccountMetas[13];
        /** The NFT deposit receipt account, which tracks an NFT to the order state it was deposited to. */
        orderNftReceipt?: TAccountMetas[14] | undefined;
    };
    data: LockOrderInstructionData;
};
export declare function parseLockOrderInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedLockOrderInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=lockOrder.d.ts.map