/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_PRICE_LOCK_PROGRAM_ADDRESS } from '../programs';
import { OrderType, OrderTypeArgs } from '../types';
export type UpsertOrderInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMaker extends string | IAccountMeta<string> = string, TAccountOrderState extends string | IAccountMeta<string> = string, TAccountOrderVault extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMarginAccount extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountCurrency extends string | IAccountMeta<string> = string, TAccountMakerToken extends string | IAccountMeta<string> = string, TAccountOrderTa extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountTlockProgram extends string | IAccountMeta<string> = 'TLoCKic2wGJm7VhZKumih4Lc35fUhYqVMgA4j389Buk', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMaker extends string ? WritableSignerAccount<TAccountMaker> & IAccountSignerMeta<TAccountMaker> : TAccountMaker,
    TAccountOrderState extends string ? WritableAccount<TAccountOrderState> : TAccountOrderState,
    TAccountOrderVault extends string ? WritableAccount<TAccountOrderVault> : TAccountOrderVault,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMarginAccount extends string ? WritableAccount<TAccountMarginAccount> : TAccountMarginAccount,
    TAccountMakerBroker extends string ? ReadonlyAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountCurrency extends string ? ReadonlyAccount<TAccountCurrency> : TAccountCurrency,
    TAccountMakerToken extends string ? WritableAccount<TAccountMakerToken> : TAccountMakerToken,
    TAccountOrderTa extends string ? WritableAccount<TAccountOrderTa> : TAccountOrderTa,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountTlockProgram extends string ? ReadonlyAccount<TAccountTlockProgram> : TAccountTlockProgram,
    ...TRemainingAccounts
]>;
export type UpsertOrderInstructionData = {
    discriminator: ReadonlyUint8Array;
    /** Defaults orderId to random 32 bytes if not specified otherwise */
    orderId: ReadonlyUint8Array;
    orderType: OrderType;
    price: bigint;
    expireInSec: Option<bigint>;
    aprBps: number;
    durationSec: number;
};
export type UpsertOrderInstructionDataArgs = {
    /** Defaults orderId to random 32 bytes if not specified otherwise */
    orderId: ReadonlyUint8Array;
    orderType: OrderTypeArgs;
    price: number | bigint;
    expireInSec?: OptionOrNullable<number | bigint>;
    aprBps: number;
    durationSec?: number;
};
export declare function getUpsertOrderInstructionDataEncoder(): Encoder<UpsertOrderInstructionDataArgs>;
export declare function getUpsertOrderInstructionDataDecoder(): Decoder<UpsertOrderInstructionData>;
export declare function getUpsertOrderInstructionDataCodec(): Codec<UpsertOrderInstructionDataArgs, UpsertOrderInstructionData>;
export type UpsertOrderAsyncInput<TAccountMaker extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountWhitelist extends string = string, TAccountMarginAccount extends string = string, TAccountMakerBroker extends string = string, TAccountCurrency extends string = string, TAccountMakerToken extends string = string, TAccountOrderTa extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountTlockProgram extends string = string> = {
    maker: TransactionSigner<TAccountMaker>;
    orderState?: Address<TAccountOrderState>;
    orderVault?: Address<TAccountOrderVault>;
    whitelist: Address<TAccountWhitelist>;
    marginAccount?: Address<TAccountMarginAccount>;
    makerBroker?: Address<TAccountMakerBroker>;
    currency?: Address<TAccountCurrency>;
    makerToken?: Address<TAccountMakerToken>;
    orderTa?: Address<TAccountOrderTa>;
    tokenProgram?: Address<TAccountTokenProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    tlockProgram?: Address<TAccountTlockProgram>;
    orderId?: UpsertOrderInstructionDataArgs['orderId'];
    orderType: UpsertOrderInstructionDataArgs['orderType'];
    price: UpsertOrderInstructionDataArgs['price'];
    expireInSec?: UpsertOrderInstructionDataArgs['expireInSec'];
    aprBps: UpsertOrderInstructionDataArgs['aprBps'];
    durationSec?: UpsertOrderInstructionDataArgs['durationSec'];
};
export declare function getUpsertOrderInstructionAsync<TAccountMaker extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountWhitelist extends string, TAccountMarginAccount extends string, TAccountMakerBroker extends string, TAccountCurrency extends string, TAccountMakerToken extends string, TAccountOrderTa extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountTlockProgram extends string>(input: UpsertOrderAsyncInput<TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountMarginAccount, TAccountMakerBroker, TAccountCurrency, TAccountMakerToken, TAccountOrderTa, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTlockProgram>): Promise<UpsertOrderInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountMarginAccount, TAccountMakerBroker, TAccountCurrency, TAccountMakerToken, TAccountOrderTa, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTlockProgram>>;
export type UpsertOrderInput<TAccountMaker extends string = string, TAccountOrderState extends string = string, TAccountOrderVault extends string = string, TAccountWhitelist extends string = string, TAccountMarginAccount extends string = string, TAccountMakerBroker extends string = string, TAccountCurrency extends string = string, TAccountMakerToken extends string = string, TAccountOrderTa extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountTlockProgram extends string = string> = {
    maker: TransactionSigner<TAccountMaker>;
    orderState: Address<TAccountOrderState>;
    orderVault: Address<TAccountOrderVault>;
    whitelist: Address<TAccountWhitelist>;
    marginAccount?: Address<TAccountMarginAccount>;
    makerBroker?: Address<TAccountMakerBroker>;
    currency?: Address<TAccountCurrency>;
    makerToken?: Address<TAccountMakerToken>;
    orderTa?: Address<TAccountOrderTa>;
    tokenProgram?: Address<TAccountTokenProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    tlockProgram?: Address<TAccountTlockProgram>;
    orderId?: UpsertOrderInstructionDataArgs['orderId'];
    orderType: UpsertOrderInstructionDataArgs['orderType'];
    price: UpsertOrderInstructionDataArgs['price'];
    expireInSec?: UpsertOrderInstructionDataArgs['expireInSec'];
    aprBps: UpsertOrderInstructionDataArgs['aprBps'];
    durationSec?: UpsertOrderInstructionDataArgs['durationSec'];
};
export declare function getUpsertOrderInstruction<TAccountMaker extends string, TAccountOrderState extends string, TAccountOrderVault extends string, TAccountWhitelist extends string, TAccountMarginAccount extends string, TAccountMakerBroker extends string, TAccountCurrency extends string, TAccountMakerToken extends string, TAccountOrderTa extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountTlockProgram extends string>(input: UpsertOrderInput<TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountMarginAccount, TAccountMakerBroker, TAccountCurrency, TAccountMakerToken, TAccountOrderTa, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTlockProgram>): UpsertOrderInstruction<typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMaker, TAccountOrderState, TAccountOrderVault, TAccountWhitelist, TAccountMarginAccount, TAccountMakerBroker, TAccountCurrency, TAccountMakerToken, TAccountOrderTa, TAccountTokenProgram, TAccountSystemProgram, TAccountAssociatedTokenProgram, TAccountTlockProgram>;
export type ParsedUpsertOrderInstruction<TProgram extends string = typeof TENSOR_PRICE_LOCK_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        maker: TAccountMetas[0];
        orderState: TAccountMetas[1];
        orderVault: TAccountMetas[2];
        whitelist: TAccountMetas[3];
        marginAccount?: TAccountMetas[4] | undefined;
        makerBroker?: TAccountMetas[5] | undefined;
        currency?: TAccountMetas[6] | undefined;
        makerToken?: TAccountMetas[7] | undefined;
        orderTa?: TAccountMetas[8] | undefined;
        tokenProgram: TAccountMetas[9];
        systemProgram: TAccountMetas[10];
        associatedTokenProgram: TAccountMetas[11];
        tlockProgram: TAccountMetas[12];
    };
    data: UpsertOrderInstructionData;
};
export declare function parseUpsertOrderInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUpsertOrderInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=upsertOrder.d.ts.map